import csv


from tklib.tkfile import tkFile
import tklib.tkre as tkre


class tkDataFile(tkFile):
    """ 
    tklib Data File class
    """

    def __init__(self, path = None, mode = 'r', OpenFile = 1, **args):
        super(tkIniFile, self).__init__(path, mode, OpenFile, **args)

        self.labelarray    = []
        self.datalistarray = []

    def __del__(self):
        self.Close()
        super(tkIniFile, self).__del__()

    def __str__(self):
        return self.ClassPath()


    def GetArrayData(self, idx):
        pass
        """
	my $pLabelList = $this->LabelArray();
	my $pDataArray = $this->DataArray();
	my $nArray     = $this->nDataArray();
#	my $nData      = $this->nData();
#print "p=$pLabelList\n";
#print "p=$pDataArray\n";

	return undef if(!defined $pDataArray->[0]->[$idx]);
	my @array;
	for(my $i = 0 ; $i < $nArray ; $i++) {
		$array[$i] = $pDataArray->[$i]->[$idx];
	}
	return \@array;
        """

    def GetHashData(self):
        pass
        """
	my $pLabelList = $this->LabelArray();
	my $pDataArray = $this->DataArray();
	my $nArray     = $this->nDataArray();
#	my $nData      = $this->nData();
#print "p=$pLabelList\n";
#print "p=$pDataArray\n";

	return undef if(!defined $pDataArray->[0]->[$idx]);
	my %hash;
	for(my $i = 0 ; $i < $nArray ; $i++) {
		$hash{$pLabelList->[$i]} = $pDataArray->[$i]->[$idx];
	}
	return \%hash;
        """

    def FindLabelIndex(self, regexp, flag = ''):
        for i in range(len(self.labelarray)):
#            print("search", regexp, self.labelarray[i])
            if tkre.Search(regexp, self.labelarray[i], flag):
                return i
        return None

    def FindDataArray(self, regexp, flag = ''):
#        print("labels=", self.labelarray)
#        print("data=", self.datalistarray)
        idx = self.FindLabelIndex(regexp, flag)
        try:
            return self.labelarray[idx], self.datalistarray[idx]
        except:
            return None, None

 